#include <stdio.h>
#include <math.h>
#include "graph.h"
#include <ppm.h>

#include "GL.h"
#include "GC.h"

#define dbg 0//1 printʸɽ

//뺹
#define max_disparity 64

//֥å
#define block_size 3


int main(int argc, char **argv)
{
  //ϲ
  uchar **LImg;
  uchar **RImg;

  //ϲ
  uchar **outImg;

  /* ppmեѿ */
  pixval maxval;
  int col, row,format;
  FILE *ifp;
  pixel **Limg;
  pixel **Rimg;


  char* outfile;
  outfile = argv[3];

  int width,height,i,j,process;
  
  int **disparity_array;

  /**************************

     ޥɥå 

   **************************/
  if(argc != 4){
    fprintf(stderr,"Usage: %s  ϲ\n", argv[0]);
    return -1;
  }

  /**************************

     ΰ

   **************************/
  
  // col row maxval format
  #if dbg
  fprintf(stderr,"get col,row,maxval,format\n");
  #endif 
 if((ifp = fopen(argv[1], "r")) == NULL){ 
    fprintf(stderr, "Can't open %s for read!!\n", argv[1]);
    exit(1);
  }
  ppm_readppminit( ifp, &col, &row, &maxval, &format );
  fprintf(stderr, "col =%d row = %d\n",col,row);
   fclose(ifp);
  //ΰ
  #if dbg
  fprintf(stderr,"ΰ\n");
  #endif
  LImg = (unsigned char **)malloc(sizeof(unsigned char *) * row );
  RImg = (unsigned char **)malloc(sizeof(unsigned char *) * row );  
  outImg = (unsigned char **)malloc(sizeof(unsigned char *) * row );  

  //ƥݥ󥿤ФơƤ  
  for (i = 0; i < row; i++)
    {
      LImg[i] = (unsigned char *)malloc(sizeof(unsigned char) * col);
      RImg[i] = (unsigned char *)malloc(sizeof(unsigned char *) * col );
      outImg[i] = (unsigned char *)malloc(sizeof(unsigned char *) * col );  
    }  

  //
  #if dbg
  fprintf(stderr,"\n");
  #endif 

  for (j = 0; j < row; j++)
    for (i = 0; i < col; i++)
      {
	LImg[j][i] = 0;
	RImg[j][i] = 0;
	outImg[j][i] = 0;
      }

  /* ɤ߹ */
  #if dbg
  printf("leftɤ߹\n");
  #endif
 
  /* ե륪ץ */
  if((ifp = fopen(argv[1], "r")) == NULL){ 
    fprintf(stderr, "Can't open %s for read!!\n", argv[1]);
    exit(1);
  }
  /* ˳Ǽ */
  Limg = ppm_readppm(ifp, &col, &row, &maxval);
  
  #if dbg
  printf("leftɤ߹ߴλ\n");
  printf("rightɤ߹\n");
  #endif

  /* ե륯 */
  fclose(ifp);

  /* ե륪ץ */
  if((ifp = fopen(argv[2], "r")) == NULL){ 
    fprintf(stderr, "Can't open %s for read!!\n", argv[1]);
    exit(1);
  }
  /* ˳Ǽ */
  Rimg = ppm_readppm(ifp, &col, &row, &maxval);
 
  #if dbg
  printf("rightɤ߹ߴλ\n");
  #endif
  
  /* ե륯 */
  fclose(ifp);
  #if dbg
  fprintf(stderr, "졼Ѵ\n");
  #endif
  /* 졼Ѵ */
  for (j = 0; j < row; j++)
    for (i = 0; i < col; i++)
      {
	LImg[j][i] =(unsigned char) (  0.299 * PPM_GETR(Limg[j][i])  
				       + 0.587 * PPM_GETG(Limg[j][i]) 
				       + 0.114 * PPM_GETB(Limg[j][i])
				       );
	
	RImg[j][i] =(unsigned char) (  0.299 * PPM_GETR(Rimg[j][i])  
				       + 0.587 * PPM_GETG(Rimg[j][i]) 
				       + 0.114 * PPM_GETB(Rimg[j][i])
				       );
      }
  #if dbg
  fprintf(stderr, "졼Ѵλ\n");
  #endif

  //ˡɤ߹
  fprintf(stdout, "ˡ?\n");
  fprintf(stdout,
	  "1: block maching\n\
2: Alpha expansion\n\
3:Hierarchical graph cut\n");
  scanf("%d", &process);

   
    //뺹ΰݤ
    disparity_array=disparity_Array(max_disparity);
  
    switch(process)
      {
      case 1:
	{
	  //block maching
	  block_matching(LImg,RImg,outImg,col,row,max_disparity,block_size);
	  break;
	}
      case 2:
	{
	  // Alpha expansion
	  alpha_expansion(LImg,RImg,outImg,
				 col,row,max_disparity,block_size);
	  break;
	}
      case 3:
	{
	  //Hierarchical graph cut
	  hierarchical(LImg,RImg,outImg,
			      col,row,max_disparity,block_size,disparity_array);
	  break;
	}
      default:
	{
	  fprintf(stderr,"INPUT  ERROR PLEASE 1,2,3\n");
	  break;
	}
      }
  
    
  //****뺹Ϥ****//
    write_Pgm(outfile,outImg,col,row,255);

}

