#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>


typedef unsigned char uchar;


double Max(double,double);


uchar *alloc_1Dub(int);
uchar **alloc_2Dub(int,int);
int **alloc_2Di(int,int);
double **alloc_2Dd(int,int);

void write_Pgm(char*,uchar**,int,int,int);
double Max(double a,double b)
{
  if(a>=b)
    return a;
  else
    return b;
}

uchar *alloc_1Dub(int w)
{
  uchar *data;

  data=(uchar*)malloc(sizeof(uchar)*w);

  return data;
}

uchar **alloc_2Dub(int w,int h)
{
  uchar *data;
  uchar **pdata;

  data=(uchar*)malloc(sizeof(uchar)*w*h);

  pdata=(uchar**)malloc(sizeof(uchar*)*h);
  for(int i=0;i<h;++i)
    pdata[i]=&data[i*w];

  for(int i=0;i<w*h;i++)
    data[i]=0;

  return pdata;
}

int **alloc_2Di(int w,int h)
{
  int *data;
  int **pdata;

  data=(int*)malloc(sizeof(int)*w*h);

  pdata=(int**)malloc(sizeof(int*)*h);
  for(int i=0;i<h;i++)
    pdata[i]=&data[i*w];

  for(int i=0;i<w*h;i++)
    data[i]=0;

  return pdata;
}

double **alloc_2Dd(int w,int h)
{
  double *data;
  double **pdata;

  data=(double*)malloc(sizeof(double)*w*h);

  pdata=(double**)malloc(sizeof(double*)*h);
  for(int i=0;i<h;i++)
    pdata[i]=&data[i*w];

  for(int i=0;i<w*h;i++)
    data[i]=0.0;

  return pdata;
}

void write_Pgm(char *filename,
		      unsigned char **data,int width,int height,int maxval)
{
  FILE *fp;
 
  fp=fopen(filename,"w");

  fprintf(fp,"P2\n#Created by \n%d %d\n%d\n",width,height,maxval);

  for(int j=0;j<height;j++)
    for(int i=0;i<width;i++)
      fprintf(fp,"%d ",data[j][i]);

  fclose(fp);
}
